diff --git a/src/buffer.h b/src/buffer.h
index f42c3e9..189fac5 100644
--- a/src/buffer.h
+++ b/src/buffer.h
@@ -736,6 +736,40 @@ struct buffer
      in the display of this buffer.  */
   Lisp_Object extra_line_spacing_;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  /* The cursor type of the real fake cursor. */
+  Lisp_Object mc_real_fake_cursor_;
+
+  /* The name of list used by multiple cursors for next redisplay. */
+  Lisp_Object mc_conf_;
+
+  /* Whether to draw multiple cursors in inactive windows. */
+  Lisp_Object mc_inactive_windows_;
+
+  /* The name of the buffer-local variable. */
+  Lisp_Object crosshairs_;
+
+  /* The name of the crosshairs horizontal ruler. */
+  Lisp_Object ch_horizontal_ruler_;
+
+  /* The name of the crosshairs vertical ruler. */
+  Lisp_Object ch_vertical_ruler_;
+
+  /* Whether to draw crosshairs in inactive windows. */
+  Lisp_Object ch_inactive_windows_;
+
+  /* The name of the buffer-local variable. */
+  Lisp_Object fc_visible_;
+
+  /* Whether to draw multiple cursors fill column in inactive windows. */
+  Lisp_Object fc_inactive_windows_;
+
+/* *************************************************************************** */
+
+
   /* Cursor type to display in non-selected windows.
      t means to use hollow box cursor.
      See `cursor-type' for other values.  */
@@ -787,14 +821,21 @@ struct buffer
      an indirect buffer since it counts as its base buffer.  */
   int window_count;
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
   /* A non-zero value in slot IDX means that per-buffer variable
      with index IDX has a local value in this buffer.  The index IDX
      for a buffer-local variable is stored in that variable's slot
      in buffer_local_flags as a Lisp integer.  If the index is -1,
      this means the variable is always local in all buffers.  */
-#define MAX_PER_BUFFER_VARS 50
+#define MAX_PER_BUFFER_VARS 60
   char local_flags[MAX_PER_BUFFER_VARS];
 
+/* *************************************************************************** */
+
+
   /* Set to the modtime of the visited file when read or written.
      modtime.tv_nsec == NONEXISTENT_MODTIME_NSECS means
      visited file was nonexistent.  modtime.tv_nsec ==
@@ -903,6 +944,69 @@ XBUFFER (Lisp_Object a)
 /* Most code should use these functions to set Lisp fields in struct
    buffer.  (Some setters that are private to a single .c file are
    defined as static in those files.)  */
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+INLINE void
+bset_blv_mc_real_fake_cursor (struct buffer *b, Lisp_Object val)
+{
+  b->mc_real_fake_cursor_ = val;
+}
+
+INLINE void
+bset_blv_mc_conf (struct buffer *b, Lisp_Object val)
+{
+  b->mc_conf_ = val;
+}
+
+INLINE void
+bset_blv_mc_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->mc_inactive_windows_ = val;
+}
+
+INLINE void
+bset_blv_crosshairs (struct buffer *b, Lisp_Object val)
+{
+  b->crosshairs_ = val;
+}
+
+INLINE void
+bset_blv_ch_horizontal_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->ch_horizontal_ruler_ = val;
+}
+
+INLINE void
+bset_blv_ch_vertical_ruler (struct buffer *b, Lisp_Object val)
+{
+  b->ch_vertical_ruler_ = val;
+}
+
+INLINE void
+bset_blv_ch_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->ch_inactive_windows_ = val;
+}
+
+INLINE void
+bset_blv_fc_visible (struct buffer *b, Lisp_Object val)
+{
+  b->fc_visible_ = val;
+}
+
+INLINE void
+bset_blv_fc_inactive_windows (struct buffer *b, Lisp_Object val)
+{
+  b->fc_inactive_windows_ = val;
+}
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 INLINE void
 bset_bidi_paragraph_direction (struct buffer *b, Lisp_Object val)
 {
diff --git a/src/dispextern.h b/src/dispextern.h
index 1a53656..4d767ea 100644
--- a/src/dispextern.h
+++ b/src/dispextern.h
@@ -100,6 +100,129 @@ typedef int Cursor;
 #define NativeRectangle int
 #endif
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+struct glyph;
+
+struct glyph_row;
+
+struct glyph_matrix;
+
+enum draw_glyphs_face;
+
+enum glyph_row_area;
+
+struct mc_matrix;
+
+enum mc_cache_type;
+
+enum mc_cursor_type;
+
+enum mc_flavor;
+
+struct mc_RGB;
+
+struct mc_essentials;
+
+enum mc_draw_row_type;
+
+enum mc_engine_type;
+
+enum mc_row_position;
+
+enum mc_redraw_row_type;
+
+enum draw_glyph_action;
+
+extern Lisp_Object mc_listn (ptrdiff_t, Lisp_Object, ...);
+
+extern Lisp_Object mc_nth (int, Lisp_Object);
+
+extern Lisp_Object mc_assq (Lisp_Object, Lisp_Object);
+
+extern enum mc_row_position mc_row_position (struct window *, struct glyph_row *,
+                                             struct glyph_row *, int);
+
+extern ptrdiff_t mc_region_limit (bool);
+
+extern struct glyph * mc_get_cursor_glyph (struct window *, struct glyph_matrix *,
+                                           struct glyph_row *, int, int);
+
+extern void mc_xw_color_values (struct window *, Lisp_Object, struct mc_RGB *);
+
+extern bool mc_update_window_fringes (struct window *, bool);
+
+extern char * mc_window (struct window *);
+
+extern char * mc_char_to_string (int);
+
+extern char * mc_cursor_type_to_string (enum mc_cursor_type);
+
+extern char * mc_flavor_to_string (enum mc_flavor);
+
+extern char * mc_cache_type_to_string (enum mc_cache_type);
+
+extern char * mc_redraw_row_type_to_string (enum mc_redraw_row_type);
+
+extern void mc_cache_inspector (struct window *, struct mc_matrix);
+
+extern bool mc_traverse_cache_p (struct mc_matrix, enum mc_cache_type, int, int);
+
+extern void mc_draw_fringe_bitmap (struct window *, struct glyph_row *, int,
+                                   enum mc_cursor_type);
+
+extern int mc_get_fringe_bitmap (struct window *, Lisp_Object, int, int);
+
+extern void mc_engine (struct window *, struct glyph_matrix *, struct glyph_row *,
+                       struct glyph *, int, int, int, int, int, int,
+                       enum mc_cursor_type, int, struct glyph_matrix *,
+                       struct mc_essentials, enum mc_row_position, struct mc_RGB,
+                       enum mc_engine_type, bool, enum mc_draw_row_type,
+                       enum mc_cache_type);
+
+extern void mc_set_essentials (struct window *, struct mc_essentials *);
+
+extern void mc_draw_row (struct window *, struct glyph_matrix *, struct glyph_row *,
+                         struct glyph *, int, int, int, struct glyph_matrix *,
+                         struct mc_essentials, enum mc_row_position, bool,
+                         enum mc_draw_row_type);
+
+extern bool mc_redraw_row (struct window *, struct glyph_matrix *, struct glyph_row *,
+                           enum glyph_row_area, int, int, int, bool,
+                           enum draw_glyphs_face, enum mc_redraw_row_type);
+
+extern void mc_reset_cache (struct window *);
+
+extern void mc_draw_cursor_glyph (struct window *, struct glyph_matrix *,
+                                  struct glyph_row *, enum draw_glyphs_face,
+                                  int, int, int, struct mc_RGB, enum mc_flavor,
+                                  enum mc_cursor_type, int, bool, bool);
+
+extern void mc_erase_cursor (struct window *, struct glyph_matrix *, struct glyph_row *,
+                             int, int, int, int, enum mc_flavor,
+                             enum mc_cursor_type, int);
+
+extern void mc_draw_erase_hybrid (struct window *, struct glyph_matrix *, struct glyph_row *,
+                                  int, int, int, int, int, int, int, int,
+                                  enum mc_cursor_type, int, struct mc_RGB,
+                                  bool, enum mc_flavor, bool);
+
+extern int mc_draw_glyphs (struct window *, struct glyph_matrix *, struct glyph_row *,
+                           int, enum glyph_row_area, ptrdiff_t, ptrdiff_t,
+                           enum draw_glyphs_face, int, int, struct mc_RGB,
+                           enum mc_flavor, enum mc_cursor_type, int, bool, bool,
+                           enum draw_glyph_action, bool);
+
+extern struct glyph_matrix * mc_save_glyph_matrix (struct glyph_matrix *);
+
+extern void mc_restore_glyph_matrix (struct glyph_matrix *, struct glyph_matrix *);
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
 /* Text cursor types.  */
 
 enum text_cursor_kinds
@@ -382,6 +505,18 @@ struct glyph_slice
 
 struct glyph
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+  int relative_x, hpos;
+
+  ptrdiff_t bytepos;
+
+/* *************************************************************************** */
+
+
   /* Position from which this glyph was drawn.  If `object' below is a
      Lisp string, this is an index into that string.  If it is a
      buffer, this is a position in that buffer.  In addition, some
@@ -1248,6 +1383,28 @@ enum draw_glyphs_face
 
 struct glyph_string
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    bool_bf left_overwritten_p : 1;
+
+    bool_bf right_overwritten_p : 1;
+
+    bool_bf rectangle_nuked_p : 1;
+
+    bool_bf background_nuked_p : 1;
+
+    enum draw_glyph_action
+    {
+      MC_DRAW_GLYPH_STRING,
+      MC_ERASE_GLYPH_STRING
+    } action_type;
+
+/* *************************************************************************** */
+
+
   /* X-origin of the string.  */
   int x;
 
@@ -2812,6 +2969,28 @@ typedef void (*frame_parm_handler) (struct frame *, Lisp_Object, Lisp_Object);
 
 struct redisplay_interface
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+/* `redisplay_interface' in `nsterm.m` | `w32term.c` | `xterm.c` must be in the
+exact same order as the `redisplay_interface' in `dispextern.h`! */
+
+  /* `mc_ns_draw_window_cursor' | `mc_w32_draw_window_cursor' | `mc_x_draw_window_cursor' */
+  void (*mc_scribe_cursor) (struct window *w, struct glyph_matrix *matrix,
+        struct glyph_row *glyph_row, int x, int fx, int y, int fy, int hpos,
+        int vpos, int wd, int h, struct mc_RGB lsl, enum mc_cursor_type cursor_type,
+        int cursor_width, enum mc_flavor glyph_flavor, bool on_p, bool active_p);
+
+  /* `mc_ns_draw_glyph_string' | `mc_w32_draw_glyph_string' | `mc_x_draw_glyph_string' */
+  void (*mc_scribe_string) (struct glyph_string *s, struct glyph_matrix *matrix, struct glyph_row *row,
+        struct mc_RGB lsl, enum mc_flavor glyph_flavor,
+        enum mc_cursor_type cursor_type, int wd, bool active_p, bool cursor_gc_p);
+
+/* *************************************************************************** */
+
+
   /* Handlers for setting frame parameters.  */
   frame_parm_handler *frame_parm_handlers;
 
